#ifndef ATLAS_SUSY_2017_04_2body_h
#define ATLAS_SUSY_2017_04_2body_h
#include "include/BaseAnalysis.h"
#include "include/HEPData.h"
#include "include/isolation.h"
#include <cmath> // for M_PI
#include <algorithm> // for sort
#include "DV.hpp"
using namespace std;


class ATLAS_SUSY_2017_04_2body : public BaseAnalysis {
    public:
       bool found_ee,found_emu,found_mumu;
       ~ATLAS_SUSY_2017_04_2body();
       void init();

       void Execute(std::mt19937 &engine);

       void Finalise() { return; }

       ATLAS_SUSY_2017_04_2body() { this->setup(); this->analysisname="ATLAS_SUSY_2017_04_2body"; this->init(); };


       void update_event_weight(vector<dv_candidate> & dv_candidates);
       void ApplyCuts(bool condition, const std::string& cutname);
       void AddCuts(const std::string& cutname);

	// declare this as a member function so we can access the histos from inside
       void do_DV_fit (vector<dv_candidate> &DV_candidates, std::mt19937 &engine);
};
#endif
